package wzmasterserver;

import java.beans.XMLDecoder;

import java.beans.XMLEncoder;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import java.net.ServerSocket;

public class Server {
    
    Configuration config;
    
    String configFilename = "wzmasterserver.config.xml";
    
    public Server() {
    }

    public static void main(String[] args) {
        Server server = new Server();
        try {
            server.run(args);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public void run(String[] args) throws Exception{
        ServerSocket socket = null;
        
        config = Configuration.getInstance();
        config.load(configFilename);
        
        try {
            System.out.println("Creating server socket to listen on port "+config.getPort()+"...");
            socket = new ServerSocket(config.getPort());
        } catch (IOException e) {
            throw new Exception("Failed creating server socket.", e);
        }
        
        SessionManager sessionManager = SessionManager.getInstance();
        
        System.out.println("Starts listening...");
        try{
            while(!Thread.interrupted()){
                sessionManager.addSession(socket.accept());
            }
        }catch(Exception e){
            System.out.println("Caught exception!");
        }finally{
            System.out.println("Shutting down...");
            sessionManager.shutDown();
        }
    }
}
